---
# ### Specify the Docker image
#
image: mcr.microsoft.com/dotnet/sdk:6.0

variables:
  # 1) Name of directory where restore and build objects are stored.
  OBJECTS_DIRECTORY: 'obj'
  # 2) Name of directory used for keeping restored dependencies.
  NUGET_PACKAGES_DIRECTORY: '.nuget'
  # 3) A relative path to the source code from project repository root.
  # NOTE: Please edit this path so it matches the structure of your project!
  SOURCE_CODE_PATH: '*/*/'
  # 4) Name of the project, used for packaging, deployment & execution.
  PROJECT_NAME: FIOWeb
  

stages:
  - build
  - test
  - package
  - deploy
  - relaunch

cache:
  # Per-stage and per-branch caching.
  key: "$CI_JOB_STAGE-$CI_COMMIT_REF_SLUG"
  paths:
    - '$SOURCE_CODE_PATH$OBJECTS_DIRECTORY/project.assets.json'
    - '$SOURCE_CODE_PATH$OBJECTS_DIRECTORY/*.csproj.nuget.*'
    - '$NUGET_PACKAGES_DIRECTORY'
  policy: pull-push

build:
  stage: build
  # ### Build all projects discovered from solution file.
  before_script:
    # ### Restore project dependencies
    - 'dotnet restore --packages $NUGET_PACKAGES_DIRECTORY'
  script:
    - 'dotnet build --no-restore'

tests:
  stage: test
  # ### Build all projects discovered from solution file.
  before_script:
    # ### Restore project dependencies
    - 'dotnet restore --packages $NUGET_PACKAGES_DIRECTORY'
  script:
    - 'dotnet test --no-restore'

package:
  stage: package
  # ### Build all projects discovered from solution file.
  before_script:
    # ### Restore project dependencies
    - 'dotnet restore --packages $NUGET_PACKAGES_DIRECTORY'
  artifacts:
    name: "$PROJECT_NAME-$CI_COMMIT_SHORT_SHA"
    paths:
      - publish/$PROJECT_NAME
    expire_in: 1 week
  script:
    - dotnet publish $PROJECT_NAME.csproj -c Release -o $CI_PROJECT_DIR/publish/$PROJECT_NAME 
    #(cont) /p:Version=`echo $CI_COMMIT_TAG | sed 's/.*\///'`
    - echo `pwd`
    - echo "$CI_PROJECT_DIR"
    - ls $CI_PROJECT_DIR
    - echo $CI_COMMIT_SHORT_SHA | sed 's/.*\///' >> $CI_PROJECT_DIR/publish/$PROJECT_NAME/version
    - ls $CI_PROJECT_DIR
  only:
    - master
    - cicd

deploy:
  stage: deploy
  needs: [package]
  script:
    # install openssh
    - apt-get update --quiet
    - apt-get install --quiet --yes openssh-client
    - tar -zcf $PROJECT_NAME-$CI_COMMIT_SHORT_SHA.tgz -C publish $PROJECT_NAME
    - chmod 600 $deploy_id_rsa
    # create paths, copy tarball, extract
    - ssh -oStrictHostKeyChecking=no -i $deploy_id_rsa -p $deploy_port $deploy_user@$deploy_host "mkdir -p $deploy_path dls"
    - scp -oStrictHostKeyChecking=no -i $deploy_id_rsa -P $deploy_port $PROJECT_NAME-$CI_COMMIT_SHORT_SHA.tgz $deploy_user@$deploy_host:dls/
    - ssh -oStrictHostKeyChecking=no -i $deploy_id_rsa -p $deploy_port $deploy_user@$deploy_host "tar -zxf dls/$PROJECT_NAME-$CI_COMMIT_SHORT_SHA.tgz"
    # keep the latest 5 archives.
    - ssh -oStrictHostKeyChecking=no -i $deploy_id_rsa -p $deploy_port $deploy_user@$deploy_host "cd dls && ls -1tr | head -n -5 | xargs -d '\n' rm -f --"
    - echo "Deployed to server"
  environment:
    name: production
  when: manual
  only:
    - master
    - cicd
